# Expected failures in mock, hangs in koji
%bcond_with tests
# The *.py files we ship are not python scripts, #813651
%global _python_bytecompile_errors_terminate_build 0
%global rhelname bash-completion

Name:           bash-completion-extras
Version:        2.1
Release:        11%{?dist}
Epoch:          1
Summary:        Additional programmable completions for Bash

License:        GPLv2+
URL:            http://bash-completion.alioth.debian.org/
Source0:        http://bash-completion.alioth.debian.org/files/%{rhelname}-%{version}.tar.bz2
Source2:        CHANGES.package.old
# https://bugzilla.redhat.com/677446, see also noblacklist patch
Source3:        %{rhelname}-2.0-redefine_filedir.bash
Source4:        core_list
# https://bugzilla.redhat.com/677446, see also redefine_filedir source
Patch0:         %{rhelname}-1.99-noblacklist.patch
# Commands included in util-linux >= 2.23-rc2
Patch1:         %{rhelname}-2.1-util-linux-223.patch

BuildArch:      noarch
%if %{with tests}
BuildRequires:  dejagnu
BuildRequires:  screen
BuildRequires:  tcllib
%endif
Requires:       bash >= 4.1
Requires:       %{rhelname} >= %{version}

%description
bash-completion is a collection of shell functions that take advantage
of the programmable completion feature of bash.

This package provides additional bash completion functionality covering
applications provided in the base operating system.


%prep
%setup -q -n %{rhelname}-%{version}
%patch0 -p1
%if 0%{?fedora} >= 19 || 0%{?rhel} >= 7
%patch1 -p1
%endif
install -pm 644 %{SOURCE2} .


%build
%configure
make %{?_smp_mflags}


%install
make install DESTDIR=$RPM_BUILD_ROOT
rm $RPM_BUILD_ROOT%{_sysconfdir}/profile.d/bash_completion.sh
rm $RPM_BUILD_ROOT%{_datadir}/pkgconfig/bash-completion.pc
rm -rf $RPM_BUILD_ROOT%{_datadir}/bash-completion/helpers/
rm -rf $RPM_BUILD_ROOT%{_datadir}/bash-completion/bash_completion


# Updated completion shipped in cowsay package:
rm $RPM_BUILD_ROOT%{_datadir}/bash-completion/completions/{cowsay,cowthink}
%if 0%{?fedora} < 19 && 0%{?rhel} < 7
# systemd >= 198 ships this one:
install -pm 644 completions/_udevadm \
    $RPM_BUILD_ROOT%{_datadir}/bash-completion/completions/udevadm
%endif
%if 0%{?fedora} > 17 || 0%{?rhel} >= 7
# NetworkManager >= 0.9.8.0 ships this one:
rm $RPM_BUILD_ROOT%{_datadir}/bash-completion/completions/nmcli

# This one ships in rpm, so delete it too
rm $RPM_BUILD_ROOT%{_datadir}/bash-completion/completions/rpm
%endif

%if 0%{?rhel} >= 7
# remove all completions except for the script list
pushd $RPM_BUILD_ROOT%{_datadir}/bash-completion/completions/
for file in *; do
  grep -q -F "$file" %{SOURCE4} || rm "$file"
done
for cmpl in find ip mount passwd ping quota ssh sudo \
    useradd usermod userdel xz ; do
      rm "$cmpl"
done
popd
%endif

%if %{with tests}
%check
# For some tests involving non-ASCII filenames
export LANG=en_US.UTF-8
# This stuff borrowed from dejagnu-1.4.4-17 (tests need a terminal)
tmpfile=$(mktemp)
screen -D -m sh -c '( make check ; echo $? ) >'$tmpfile
cat $tmpfile
result=$(tail -n 1 $tmpfile)
rm -f $tmpfile
exit $result
%endif


%files
%doc AUTHORS CHANGES CHANGES.package.old COPYING README
%{_datadir}/bash-completion/*


%changelog
* Thu Jun 16 2016 Jim Perrin <jperrin@centos.org> - 1.2.1-11
- remove completion collision for rpm

* Fri May 27 2016 Jim Perrin <jperrin@centos.org> - 1.2.1-10
- minor fixup to previous bz closure

* Wed May 25 2016 Jim Perrin <jperrin@centos.org> - 1.2.1-9
- fix duplicate provides, bz #1339420

* Tue Sep 22 2015 Jim Perrin <jperrin@centos.org> - 1.2.1-8
- change define to global
- trailing whitespace cleanup

* Fri Sep 19 2014 Jim Perrin <jperrin@centos.org> - 1:2.1-7
- Adding epoch to changelog per bz #1129505

* Wed Aug 6 2014 Jim Perrin <jperrin@centos.org> - 2.1-6
- Initial import and rename of el7 bash-completion srpm.
- remove all completions except those provided in core_list

* Fri Nov 1 2013 Petr Stodulka <pstodulk@redhat.com> - 2.1-6
- Install only available completions (#810343 - comment 15)
  without "tar" and remove the other.

